#
# spec file for package at
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           at
BuildRequires:  bison flex pam-devel
BuildRequires:  libselinux-devel
Url:            ftp://ftp.debian.org/debian/pool/main/a/at
License:        GPLv2+
Group:          System/Daemons
AutoReqProv:    on
Version:        3.1.8
Release:        1094.3.1
Summary:        A Job Manager
Source:         at_3.1.8-11.tar.gz
Source1:        atd.init
Source2:        atd.pamd
Source3:        sysconfig.atd
Source4:        at.sleep
Patch0:         %{name}-%{version}.patch
Patch1:         %{name}-%{version}-bison.patch
Patch2:         %{name}-%{version}-delete_r.patch
Patch3:         %{name}-%{version}-ttime.patch
Patch4:         %{name}-%{version}-joblist.patch
Patch5:         %{name}-%{version}-selinux.patch
Patch6:         %{name}-%{version}-pie.patch
Patch7:         %{name}-%{version}-eal3-manpages.patch
Patch8:         %{name}-%{version}-formatbugs.patch
Patch9:         %{name}-%{version}-pam.patch
Patch10:        %{name}-%{version}-massive_batch.patch
Patch11:        %{name}-%{version}-documentation-dir.patch
Patch12:        %{name}-%{version}-queue-nice-level.patch
# PATCH-FIX-UPSTREAM cleanup_perm fix permissions for unlink (bnc#478733)
Patch13:        %{name}-%{version}-cleanup_perm.patch
# PATCH-FIX-UPSTRAM pam-session-as-root (bnc#408986, bnc#239210)
Patch14:        %{name}-%{version}-pam-session-as-root.patch
# PATCH-FIX-UPSTRAM clean-up opened descriptors (bnc#533454, bnc#523346)
Patch15:        %{name}-%{version}-leak-fix.patch
#PATCH_FIX-OPENSUSE add proper system users to the deny list
Patch16:        at-3.1.8-denylist.patch
#PATCH_FIX-OPENSUSE plan jobs with past time to tomorrow (bnc#672586)
Patch17:        %{name}-%{version}-tomorrow.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
PreReq:         %{_sbindir}/useradd %{_sbindir}/groupadd %fillup_prereq %insserv_prereq
Recommends:     smtp_daemon

%description
This program allows you to run jobs at specified times.



Authors:
--------
    Thomas Koenig <ig25@rz.uni-karlsruhe.de>
    David Parsons <orc@pell.chi.il.us>
    Martin Schulze <joey@debian.org>
    Siggy Brentrup <bsb@winnegan.de>

%prep
%setup -q
%patch0
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6
%patch7
%patch8
%patch9
%patch10
%patch11
%patch12
%patch13
%patch14
%patch15
%patch16
%patch17 -p1

%build
%{?suse_update_config:%{suse_update_config -f}}
rm -fv y.tab.c y.tab.h lex.yy.c lex.yy.o y.tab.o
autoconf
export SENDMAIL=%{_sbindir}/sendmail
%configure \
  --with-pam \
  --with-selinux \
  --with-daemon_username=at \
  --with-daemon_groupname=at
make

%install
mkdir -p $RPM_BUILD_ROOT/etc/{init.d,pam.d}
mkdir -p $RPM_BUILD_ROOT/usr/{bin,sbin,share/man/man{1,5,8}}
mkdir -p $RPM_BUILD_ROOT/var/adm/fillup-templates
export CFLAGS="$RPM_OPT_FLAGS"
export SENDMAIL=%{_sbindir}/sendmail
make install IROOT=$RPM_BUILD_ROOT
# Don't install docs here in this way
mkdir docs
mv $RPM_BUILD_ROOT/%{_prefix}/doc/at/* docs/
install %SOURCE1 $RPM_BUILD_ROOT/etc/init.d/atd
ln -sf ../../etc/init.d/atd $RPM_BUILD_ROOT%{_sbindir}/rcatd
install -m644 %SOURCE2 $RPM_BUILD_ROOT/etc/pam.d/atd
install -m644 %SOURCE3 $RPM_BUILD_ROOT/var/adm/fillup-templates
%{__install} -D -m 0755 %{S:4} %{buildroot}%{_sysconfdir}/pm/sleep.d/99%{name}

%pre
%{_sbindir}/groupadd -g 25 -o -r at 2> /dev/null || :
%{_sbindir}/useradd -r -o -g at -u 25 -s /bin/bash -c "Batch jobs daemon" -d /var/spool/atjobs at 2> /dev/null || :

%preun
%stop_on_removal atd

%post
# update hack
# the rcscript used to be /etc/init.d/at
if [ -f etc/init.d/at ] ; then
rm -f etc/init.d/at
%{insserv_cleanup}
fi
%{fillup_and_insserv -n atd atd }
%run_permissions

%postun
%restart_on_update atd
%insserv_cleanup

%files
%defattr(-,root,root)
%doc Problems Copyright README ChangeLog timespec
%config(noreplace) /etc/at.deny
%dir %{_sysconfdir}/pm
%dir %{_sysconfdir}/pm/sleep.d
%config %{_sysconfdir}/pm/sleep.d/99%{name}
%{_sbindir}/rcatd
%config /etc/init.d/atd
%config %attr(644,root,root) /etc/pam.d/atd
%verify(not mode) %attr(4750,root,trusted) %{_bindir}/at
%{_bindir}/atq
%{_bindir}/atrm
%{_bindir}/batch
%{_mandir}/man?/*
%{_sbindir}/atd
%{_sbindir}/atrun
%attr(700,at,at) %dir /var/spool/atspool
%attr(700,at,at) %dir /var/spool/atjobs
%attr(600,at,at) /var/spool/atjobs/.SEQ
/var/adm/fillup-templates/sysconfig.atd

%changelog
* Tue Mar  1 2011 vcizek@novell.com
- fixed bug introduced with at-3.1.8-tomorrow.patch (bnc#672586)
* Mon Feb  7 2011 jslaby@suse.de
- source pm-utils functions in suspend/resume script to avoid
  errors
* Tue Feb  1 2011 vcizek@novell.com
- at now shifts jobs with passed time without a date to tomorrow
  (bnc#668485)
* Wed Nov 10 2010 coolo@novell.com
- own parent directories
* Tue Sep 28 2010 cristian.rodriguez@opensuse.org
- /etc/at.deny has wrong account name [bnc#632250]
* Tue Jul 20 2010 cristian.rodriguez@opensuse.org
- wake up atd after suspend [bnc#592349]
* Sat Jul 17 2010 cristian.rodriguez@opensuse.org
- improve spec file
- Should Recommend smtp_daemon
* Wed Nov 18 2009 mseben@novell.com
- added pam conversion function (reworked pam.patch) fate#306386
* Tue Nov  3 2009 coolo@novell.com
- updated patches to apply with fuzz=0
* Thu Aug 27 2009 mseben@novell.com
- closedir.patch renamed to leak-fix.patch and added others fixs
  of resource leaks (bnc#533454)
* Thu Aug 13 2009 mseben@novell.com
- added closedir.patch fix missing call of closedir() (bnc#523346)
* Thu May 14 2009 puzel@suse.cz
- added at-3.1.8-pam-session-as-root.patch (bnc#329210, bnc#408986)
* Mon Mar  2 2009 sebo@suse.de
- added cleanup_perm.patch to fix permissions for unlink (bnc#478733)
* Thu Feb 12 2009 mseben@suse.cz
- fixed nice level of queues : queue-nice-level.patch [bnc#225463]
* Thu Jan  8 2009 prusnak@suse.cz
- corrected selinux.patch [bnc#463521]
* Wed Oct  8 2008 bwalle@suse.de
- Fix documentation directory in at(1).
* Mon Sep  1 2008 puzel@suse.cz
- enabled SELinux support [Fate#303662]
* Tue Apr  8 2008 mrueckert@suse.de
- add at-3.1.8_massive_batch.patch: (bnc#347126)
  properly handle sighup when multiple jobs are submitted at the
  same time
* Fri May 11 2007 mrueckert@suse.de
- remove postfix from the build requires. (#225469)
* Thu Mar 29 2007 meissner@suse.de
- buildrequires flex,bison
* Mon Mar 19 2007 mrueckert@suse.de
- readd at-3.1.8-pam.diff: (#222563)
  The breaking part of the setreuid(daemon_uid,daemon_uid) in
  perm.c. uid 25 can not write audit messages. As upstream removed
  the pam code in perm.c aswell, we do the same here.
* Mon Dec 18 2006 ro@suse.de
- added sysconfig variables ATD_BATCH_INTERVAL
  and ATD_LOADAVG (fate#301318)
* Tue Nov 28 2006 mrueckert@suse.de
- remove at-3.1.8-pam.diff it just breaks at.
* Tue Nov 21 2006 ro@suse.de
- added PRIV_START/END calls around pam_start sections (#222412)
* Fri Sep  1 2006 kukuk@suse.de
- Add pam_loginuid.so to atd.pamd
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Thu Jan 12 2006 schwab@suse.de
- Don't strip binaries.
* Mon Dec  5 2005 kukuk@suse.de
- Disable SELinux
* Mon Aug 29 2005 kukuk@suse.de
- Make pam config file non-executeable
* Thu Aug 25 2005 kukuk@suse.de
- Remove pam_loginuid.so  [may fix #112802]
* Mon Aug 15 2005 kukuk@suse.de
- Update to at-3.1.8-11 tarball (includes old patches)
- Add PAM support
* Thu Jun  2 2005 kukuk@suse.de
- Compile with -fpie/-pie
- Update SELinux patch
* Sat Feb  5 2005 meissner@suse.de
- mark up for format string using functions.
- fixed one error output
* Tue May 25 2004 ro@suse.de
- added "-t" docu to manpage
* Thu Mar 25 2004 mmj@suse.de
- Add postfix to # neededforbuild
* Tue Mar 23 2004 thomas@suse.de
- Added patch for EAL3 man-pages
* Tue Mar 23 2004 thomas@suse.de
- Added patch for LAuS
* Wed Jan 28 2004 kukuk@suse.de
- Add patch for SELinux
* Mon Oct 27 2003 ro@suse.de
- package /usr/bin/at as 4750,root,trusted as in permissions.secure
- add verify (not mode) for /usr/bin/at
- add run_permissions macro to postinstall
* Sun Oct 19 2003 ro@suse.de
- don't build as root
* Tue Oct  7 2003 ro@suse.de
- support "at -l -q queue" and "-t timespec" (#31957)
  (ported from FreeBSD)
* Fri Aug 29 2003 kukuk@suse.de
- Create at as system account [Bug #29611]
* Fri Aug 15 2003 ro@suse.de
- make "at -r" behave like "at -d" (#28753)
- added restart_on_update/stop_on_removal macros
* Fri Jul 18 2003 kukuk@suse.de
- Fix spec file/Makefile to be able to build as normal user
* Wed Jun 18 2003 ro@suse.de
- added "X-UnitedLinux-Default-Enabled: no" to init-script
* Wed Jun 18 2003 ro@suse.de
- don't activate by default
* Mon May 19 2003 ro@suse.de
- fix filelist
* Mon May 12 2003 ro@suse.de
- use defattr
* Tue Mar 11 2003 ro@suse.de
- fix postinstall for updates (appeared in #24653)
* Thu Nov  7 2002 tcrhak@suse.cz
- fixed for bison 1.75: end rules with semicolon
* Fri Aug 23 2002 bk@suse.de
- mark /etc/at.deny as noreplace
* Mon Aug 19 2002 kukuk@suse.de
- Use $time instead of xntp in init script.
* Thu Aug  1 2002 ro@suse.de
- added prereqs
* Mon Jul  1 2002 ro@suse.de
- add ntp to Required-Start in init-script (#15833)
* Mon May 27 2002 ro@suse.de
- set SIGCHLD handler back to default when starting job
* Thu May 23 2002 ro@suse.de
- create user in install section
* Wed May 22 2002 kukuk@suse.de
- Create at user/group in preinstall script
* Tue Apr  2 2002 ro@suse.de
- don't try to copy config.guess and config.sub
  (already done by suse_update_config)
* Wed Jan 16 2002 ro@suse.de
- integrated two patches:
  at-3.1.8-heapcorruption.dif and at-3.1.8-o_excl.dif
  against heap corruption in time parser for commandline and for
  safer opening of a file (O_EXCL).
- removed all generated files from patch and copy config.{sub,guess}
  from current automake
* Wed Jan  9 2002 kukuk@suse.de
- Fix path to timespec in at.1 manual page [Bug #12784]
* Tue Jan  8 2002 egmont@suselinux.hu
- removed colons from init script messages
* Wed Jan  2 2002 kukuk@suse.de
- Remove warning about cron and at (never worked before and user
  cannot see it)
- Rename init script from at to atd
- Don't source rc.config in init script (not needed any longer)
- Remove $route from init script dependencies (does not exist)
  [Bug #12689]
- Use BuildRoot
* Fri Dec 14 2001 ro@suse.de
- removed START_ATD
* Mon Aug  6 2001 ro@suse.de
- updated rc script
* Fri Jun 15 2001 schwab@suse.de
- Add %%suse_update_config.
* Tue Nov 28 2000 ro@suse.de
- startscript to etc/init.d
* Mon Sep 25 2000 ro@suse.de
- sorted
* Wed Feb 16 2000 dipa@suse.de
- apply debian patch at_3.1.8-8.diff full section of: at.c, at.1.in,
  at.deny, at_allow.5, atd.8.in, at.8.in, batch config.guess,
  config.sub, daemon.c, lex.yy.c, panic.c, parsetime.y, y.tab.c
  (fix for bug #1766)
* Fri Feb  4 2000 ro@suse.de
- fix missing getlock preload
* Fri Feb  4 2000 ro@suse.de
- applied security fixes from thomas
* Mon Jan 17 2000 ro@suse.de
- man -> usr/share/man
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Tue Dec  8 1998 ro@suse.de
- added reload to script (does a restart)
* Mon Dec  7 1998 ro@suse.de
- added symlink /sbin/rcat -> init.d/at
* Mon Dec  7 1998 ro@suse.de
- updated init-script
* Fri Feb 27 1998 ro@suse.de
- installed timespec in docdir / fixed path in manpage
* Mon Oct 27 1997 ro@suse.de
- update to version 3.1.8
  ready for autobuild
* Sun Jun 22 1997 florian@suse.de
- update to version 3.1.7
* Sun Jun  1 1997 bs@suse.de
- moved fillup stuff to var/adm/fillup-templates
* Thu Jan  2 1997 bs@suse.de
  boot script beautified.
* Thu Jan  2 1997 bs@suse.de
  recompiled and added README
* Thu Jan  2 1997 bs@suse.de
- /var/spool/atspool/atspool fixed.
* Thu Jan  2 1997 bs@suse.de
- new version 3.0
- fillup etc/rc.config and sbin/init.d/at added.
* Thu Jan  2 1997 bs@suse.de
  switched to version pre-3.0-960812.
  New: atd (daemon)
  fillup etc/rc.config and sbin/init.d-stuff added.
* Thu Jan  2 1997 florian@suse.de
  allow login names to be up to 16 characters long
